diff --git a/contrib/ntp/sntp/check-libntp.mf b/contrib/ntp/sntp/check-libntp.mf
index 649f605a8d07..f27aeb66e4f7 100644
--- a/contrib/ntp/sntp/check-libntp.mf
+++ b/contrib/ntp/sntp/check-libntp.mf
@@ -4,12 +4,12 @@
 ## The above file has a version of this for the non-sntp portion
 ## of the NTP package.
 
-BUILT_SOURCES	+= check-libntp
-CLEANFILES	+= check-libntp
+.PHONY: check-libntp
 
-check-libntp: $(top_builddir)/../libntp/libntp.a
-	@: avoid default SCCS get by some make implementations
+if LIBNTP_SUBMAKES
+BUILT_SOURCES	+= check-libntp
 
-$(top_builddir)/../libntp/libntp.a:
+check-libntp:
 	cd $(top_builddir)/../libntp && $(MAKE) $(AM_MAKEFLAGS) libntp.a
 
+endif
diff --git a/contrib/ntp/sntp/check-libsntp.mf b/contrib/ntp/sntp/check-libsntp.mf
index d05a3d02fd07..297a8947a57e 100644
--- a/contrib/ntp/sntp/check-libsntp.mf
+++ b/contrib/ntp/sntp/check-libsntp.mf
@@ -3,11 +3,7 @@
 ##
 
 BUILT_SOURCES	+= check-libsntp
-CLEANFILES	+= check-libsntp
 
-check-libsntp: $(top_builddir)/sntp/libsntp.a
-	@: avoid default SCCS get by some make implementations
-
-$(top_builddir)/sntp/libsntp.a:
+.PHONY: check-libsntp
+check-libsntp:
 	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) libsntp.a
-
diff --git a/contrib/ntp/sntp/check-libunity.mf b/contrib/ntp/sntp/check-libunity.mf
index bf5ec3bde1ed..af394da6e504 100644
--- a/contrib/ntp/sntp/check-libunity.mf
+++ b/contrib/ntp/sntp/check-libunity.mf
@@ -8,8 +8,7 @@ BUILT_SOURCES	+= check-libunity
 CLEANFILES	+= check-libunity
 
 check-libunity: $(top_builddir)/unity/libunity.a
-	 @: avoid default SCCS get by some make implementations
+	@echo stamp > $@
 
 $(top_builddir)/unity/libunity.a:
 	cd $(top_builddir)/unity && $(MAKE) $(AM_MAKEFLAGS) libunity.a
-
diff --git a/contrib/ntp/sntp/config.h.in b/contrib/ntp/sntp/config.h.in
index a4a15b82fcf1..d1cd7070a106 100644
--- a/contrib/ntp/sntp/config.h.in
+++ b/contrib/ntp/sntp/config.h.in
@@ -18,6 +18,9 @@
 /* number of args to el_init() */
 #undef EL_INIT_ARGS
 
+/* Enable CMAC support? */
+#undef ENABLE_CMAC
+
 /* nls support in libopts */
 #undef ENABLE_NLS
 
@@ -131,9 +134,6 @@
 /* Define to 1 if the system has the type `int32'. */
 #undef HAVE_INT32
 
-/* int32 type in DNS headers, not others. */
-#undef HAVE_INT32_ONLY_WITH_DNS
-
 /* Define to 1 if the system has the type `int32_t'. */
 #undef HAVE_INT32_T
 
@@ -260,9 +260,6 @@
 /* Define to 1 if you have the <openssl/cmac.h> header file. */
 #undef HAVE_OPENSSL_CMAC_H
 
-/* Define to 1 if you have the <openssl/hmac.h> header file. */
-#undef HAVE_OPENSSL_HMAC_H
-
 /* Define this if pathfind(3) works */
 #undef HAVE_PATHFIND
 
@@ -314,6 +311,12 @@
 /* Define to 1 if the system has the type `ptrdiff_t'. */
 #undef HAVE_PTRDIFF_T
 
+/* Define to 1 if you have the `RAND_bytes' function. */
+#undef HAVE_RAND_BYTES
+
+/* Define to 1 if you have the `RAND_poll' function. */
+#undef HAVE_RAND_POLL
+
 /* Define to 1 if you have the <readline.h> header file. */
 #undef HAVE_READLINE_H
 
@@ -464,7 +467,7 @@
 /* Define to 1 if you have the <sysexits.h> header file. */
 #undef HAVE_SYSEXITS_H
 
-/* */
+/* syslog.h provides facilitynames */
 #undef HAVE_SYSLOG_FACILITYNAMES
 
 /* Define to 1 if you have the <syslog.h> header file. */
@@ -601,9 +604,6 @@
 /* Define to 1 if the system has the type `u_int32'. */
 #undef HAVE_U_INT32
 
-/* u_int32 type in DNS headers, not others. */
-#undef HAVE_U_INT32_ONLY_WITH_DNS
-
 /* Define to 1 if you have the <values.h> header file. */
 #undef HAVE_VALUES_H
 
@@ -754,6 +754,9 @@
 /* Use OpenSSL? */
 #undef OPENSSL
 
+/* Suppress OpenSSL 3 deprecation warnings */
+#undef OPENSSL_SUPPRESS_DEPRECATED
+
 /* Name of package */
 #undef PACKAGE
 
@@ -839,10 +842,6 @@
 /* enable thread safety */
 #undef THREAD_SAFE
 
-/* Define to 1 if you can safely include both <sys/time.h> and <time.h>. This
-   macro is obsolete. */
-#undef TIME_WITH_SYS_TIME
-
 /* Provide a typedef for uintptr_t? */
 #ifndef HAVE_UINTPTR_T
 typedef unsigned int	uintptr_t;
@@ -852,6 +851,9 @@ typedef unsigned int	uintptr_t;
 /* What type to use for setsockopt */
 #undef TYPEOF_IP_MULTICAST_LOOP
 
+/* Use OpenSSL's crypto random functions */
+#undef USE_OPENSSL_CRYPTO_RAND
+
 /* OK to use snprintb()? */
 #undef USE_SNPRINTB
 
@@ -1016,15 +1018,8 @@ typedef unsigned int	uintptr_t;
 /* Define to `unsigned int' if <sys/types.h> does not define. */
 #undef size_t
 
-	
-	    #if !defined(_KERNEL) && !defined(PARSESTREAM)
-	    /*
-	     * stdio.h must be included after _GNU_SOURCE is defined
-	     * but before #define snprintf rpl_snprintf
-	     */
-	    # include <stdio.h>	
-	    #endif
-	
+	#include "c99_snprintf.h"
+    
 
 /* Define to rpl_snprintf if the replacement function should be used. */
 #undef snprintf
diff --git a/contrib/ntp/sntp/configure.ac b/contrib/ntp/sntp/configure.ac
index 43c2ad6c5828..4fb182bc0ef5 100644
--- a/contrib/ntp/sntp/configure.ac
+++ b/contrib/ntp/sntp/configure.ac
@@ -33,7 +33,7 @@ AC_LANG([C])
 # the date YYYYMMDD optionally with -HHMM if there is more than one
 # bump in a day.
 
-sntp_configure_cache_version=20120806
+sntp_configure_cache_version=20240218
 
 # When the version of config.cache and configure do not
 # match, NTP_CACHEVERSION will flush the cache.
@@ -62,8 +62,7 @@ AM_PROG_AR
 
 NTP_LIBNTP
 
-AC_DISABLE_SHARED
-AC_PROG_LIBTOOL
+LT_INIT([disable-shared])
 AC_SUBST([LIBTOOL_DEPS])
 
 NTP_WITHSNTP
@@ -82,7 +81,7 @@ esac
 # Therefore, by default:
 # - use the version we ship with
 # - do not install it
-# - build a static copy (AC_DISABLE_SHARED - done earlier)
+# - build a static copy (disable-shared - done earlier)
 case "${enable_local_libopts+set}" in
  set) ;;
  *) enable_local_libopts=yes ;;
@@ -121,7 +120,6 @@ NTP_FACILITYNAMES
 # Checks for typedefs, structures, and compiler characteristics.
 AC_HEADER_STDBOOL
 
-NTP_OPENSSL
 NTP_IPV6
 
 ###
diff --git a/contrib/ntp/sntp/crypto.c b/contrib/ntp/sntp/crypto.c
index 7807ccc00b03..1be2ea3f0c39 100644
--- a/contrib/ntp/sntp/crypto.c
+++ b/contrib/ntp/sntp/crypto.c
@@ -16,14 +16,15 @@ size_t key_cnt = 0;
 
 typedef struct key Key_T;
 
-static u_int
+static size_t
 compute_mac(
-	u_char		digest[EVP_MAX_MD_SIZE],
+	u_char *	digest,
+	size_t		dig_sz,
 	char const *	macname,
 	void const *	pkt_data,
-	u_int		pkt_size,
+	size_t		pkt_len,
 	void const *	key_data,
-	u_int		key_size
+	size_t		key_size
 	)
 {
 	u_int		len  = 0;
@@ -56,7 +57,7 @@ compute_mac(
 				    EVP_aes_128_cbc(), NULL)) {
 			msyslog(LOG_ERR, "make_mac: CMAC %s Init failed.",      CMAC);
 		}
-		else if (!CMAC_Update(ctx, pkt_data, (size_t)pkt_size)) {
+		else if (!CMAC_Update(ctx, pkt_data, pkt_len)) {
 			msyslog(LOG_ERR, "make_mac: CMAC %s Update failed.",    CMAC);
 		}
 		else if (!CMAC_Final(ctx, digest, &slen)) {
@@ -95,7 +96,7 @@ compute_mac(
 				macname);
 			goto mac_fail;
 		}
-		if (!EVP_DigestUpdate(ctx, pkt_data, pkt_size)) {
+		if (!EVP_DigestUpdate(ctx, pkt_data, pkt_len)) {
 			msyslog(LOG_ERR, "make_mac: MAC %s Digest Update data failed.",
 				macname);
 			goto mac_fail;
@@ -112,7 +113,7 @@ compute_mac(
 			goto mac_fail;
 		}
 		EVP_DigestUpdate(ctx, key_data, key_size);
-		EVP_DigestUpdate(ctx, pkt_data, pkt_size);
+		EVP_DigestUpdate(ctx, pkt_data, pkt_len);
 		EVP_DigestFinal(ctx, digest, &len);
 #endif
 	  mac_fail:
@@ -122,34 +123,28 @@ compute_mac(
 	return len;
 }
 
-int
+
+size_t
 make_mac(
 	const void *	pkt_data,
-	int		pkt_size,
-	int		mac_size,
+	size_t		pkt_len,
 	Key_T const *	cmp_key,
-	void * 		digest
+	void * 		digest,
+	size_t		dig_sz
 	)
 {
 	u_int		len;
 	u_char		dbuf[EVP_MAX_MD_SIZE];
 
-	if (cmp_key->key_len > 64 || mac_size <= 0)
-		return 0;
-	if (pkt_size % 4 != 0)
+	if (cmp_key->key_len > 64 || pkt_len % 4 != 0) {
 		return 0;
-
-	len = compute_mac(dbuf, cmp_key->typen,
-			  pkt_data, (u_int)pkt_size,
-			  cmp_key->key_seq, (u_int)cmp_key->key_len);
-
-
-	if (len) {
-		if (len > (u_int)mac_size)
-			len = (u_int)mac_size;
-		memcpy(digest, dbuf, len);
 	}
-	return (int)len;
+	len = compute_mac(dbuf, sizeof(dbuf),  cmp_key->typen, pkt_data,
+			  pkt_len, cmp_key->key_seq, cmp_key->key_len);
+	INSIST(len <= dig_sz);
+	memcpy(digest, dbuf, len);
+
+	return len;
 }
 
 
@@ -161,8 +156,8 @@ make_mac(
 int
 auth_md5(
 	void const *	pkt_data,
-	int 		pkt_size,
-	int		mac_size,
+	size_t		pkt_len,
+	size_t		mac_len,
 	Key_T const *	cmp_key
 	)
 {
@@ -170,22 +165,20 @@ auth_md5(
 	u_char const *	pkt_ptr   = pkt_data;
 	u_char		dbuf[EVP_MAX_MD_SIZE];
 
-	if (mac_size <= 0 || (size_t)mac_size > sizeof(dbuf))
+	if (0 == mac_len || mac_len > sizeof(dbuf)) {
 		return FALSE;
+	}
+	len = compute_mac(dbuf, sizeof(dbuf), cmp_key->typen,
+			  pkt_ptr, pkt_len, cmp_key->key_seq,
+			  cmp_key->key_len);
 
-	len = compute_mac(dbuf, cmp_key->typen,
-			  pkt_ptr, (u_int)pkt_size,
-			  cmp_key->key_seq, (u_int)cmp_key->key_len);
-
-	pkt_ptr += pkt_size + 4;
-	if (len > (u_int)mac_size)
-		len = (u_int)mac_size;
+	pkt_ptr += pkt_len + sizeof(keyid_t);
 
 	/* isc_tsmemcmp will be better when its easy to link with.  sntp
 	 * is a 1-shot program, so snooping for timing attacks is
 	 * Harder.
 	 */
-	return ((u_int)mac_size == len) && !memcmp(dbuf, pkt_ptr, len);
+	return mac_len == len && !memcmp(dbuf, pkt_ptr, mac_len);
 }
 
 static int
@@ -312,14 +305,15 @@ auth_init(
  */
 void
 get_key(
-	int key_id,
-	struct key **d_key
+	keyid_t		key_id,
+	struct key **	d_key
 	)
 {
 	struct key *itr_key;
 
-	if (key_cnt == 0)
+	if (key_cnt == 0) {
 		return;
+	}
 	for (itr_key = key_ptr; itr_key; itr_key = itr_key->next) {
 		if (itr_key->key_id == key_id) {
 			*d_key = itr_key;
diff --git a/contrib/ntp/sntp/crypto.h b/contrib/ntp/sntp/crypto.h
index 4e75df20a9a3..4afe865e53e5 100644
--- a/contrib/ntp/sntp/crypto.h
+++ b/contrib/ntp/sntp/crypto.h
@@ -17,18 +17,19 @@
 
 struct key {
 	struct key *	next;
-	int		key_id;
-	int		key_len;
+	keyid_t		key_id;
+	size_t		key_len;
 	int		typei;
 	char		typen[20];
 	char		key_seq[64];
 };
 
 extern	int	auth_init(const char *keyfile, struct key **keys);
-extern	void	get_key(int key_id, struct key **d_key);
-extern	int	make_mac(const void *pkt_data, int pkt_size, int mac_size,
-			 const struct key *cmp_key, void *digest);
-extern	int	auth_md5(const void *pkt_data, int pkt_size, int mac_size,
-			 const struct key *cmp_key);
+extern	void	get_key(keyid_t key_id, struct key **d_key);
+extern	size_t	make_mac(const void *pkt_data, size_t pkt_len,
+			 const struct key *cmp_key, void *digest,
+			 size_t dig_sz);
+extern	int	auth_md5(const void *pkt_data, size_t pkt_len,
+			 size_t dig_len, const struct key *cmp_key);
 
 #endif
diff --git a/contrib/ntp/sntp/include/copyright.def b/contrib/ntp/sntp/include/copyright.def
index c93887e2cdae..137ff6df4664 100644
--- a/contrib/ntp/sntp/include/copyright.def
+++ b/contrib/ntp/sntp/include/copyright.def
@@ -1,7 +1,7 @@
 /* -*- Mode: Text -*- */
 
 copyright = {
-    date  = "1992-2023";
+    date  = "1992-2024";
     owner = "The University of Delaware and Network Time Foundation";
     eaddr = "https://bugs.ntp.org, bugs@ntp.org";
     type  = ntp;
diff --git a/contrib/ntp/sntp/include/version.def b/contrib/ntp/sntp/include/version.def
index bba075cfff5f..64683799012a 100644
--- a/contrib/ntp/sntp/include/version.def
+++ b/contrib/ntp/sntp/include/version.def
@@ -1 +1 @@
-version = '4.2.8p17';
+version = '4.2.8p18';
diff --git a/contrib/ntp/sntp/libevent/configure.ac b/contrib/ntp/sntp/libevent/configure.ac
index d00e063a1474..6c2646c219de 100644
--- a/contrib/ntp/sntp/libevent/configure.ac
+++ b/contrib/ntp/sntp/libevent/configure.ac
@@ -348,7 +348,7 @@ AM_CONDITIONAL(BUILD_MIDIPIX, test x$midipix = xtrue)
 AM_CONDITIONAL(BUILD_WITH_NO_UNDEFINED, test x$bwin32 = xtrue || test x$cygwin = xtrue || test x$midipix = xtrue)
 
 if test x$bwin32 = xtrue; then
-  AC_HAVE_LIBRARY([ws2_32])
+  AC_CHECK_LIB([ws2_32], [main])
 fi
 
 dnl Checks for typedefs, structures, and compiler characteristics.
@@ -989,6 +989,11 @@ AC_SUBST([LIBEVENT_GC_SECTIONS])
 
 AM_CONDITIONAL([INSTALL_LIBEVENT], [test "$enable_libevent_install" = "yes"])
 
+dnl Aloow addtional flags from a containing package such as NTP
+AC_SUBST([LIBEVENT_CFLAGS])
+AC_SUBST([LIBEVENT_CPPFLAGS])
+AC_SUBST([LIBEVENT_LDFLAGS])
+
 # Doxygen support
 DX_HTML_FEATURE(ON)
 DX_MAN_FEATURE(OFF)
diff --git a/contrib/ntp/sntp/libevent/kqueue.c b/contrib/ntp/sntp/libevent/kqueue.c
index dfd7751d6497..14a8946fe99d 100644
--- a/contrib/ntp/sntp/libevent/kqueue.c
+++ b/contrib/ntp/sntp/libevent/kqueue.c
@@ -346,7 +346,7 @@ kq_dispatch(struct event_base *base, struct timeval *tv)
 			 * on FreeBSD. */
 			case EINVAL:
 				continue;
-#if defined(__FreeBSD__)
+#if defined(__FreeBSD__) && defined(ENOTCAPABLE)
 			/*
 			 * This currently occurs if an FD is closed
 			 * before the EV_DELETE makes it out via kevent().
diff --git a/contrib/ntp/sntp/libevent/m4/acx_pthread.m4 b/contrib/ntp/sntp/libevent/m4/acx_pthread.m4
index d2b116945f9f..92ac1089b4ee 100644
--- a/contrib/ntp/sntp/libevent/m4/acx_pthread.m4
+++ b/contrib/ntp/sntp/libevent/m4/acx_pthread.m4
@@ -86,7 +86,7 @@
 AC_DEFUN([ACX_PTHREAD], [
 AC_REQUIRE([AC_CANONICAL_HOST])
 AC_LANG_SAVE
-AC_LANG_C
+AC_LANG([C])
 acx_pthread_ok=no
 
 # We used to check for pthread.h first, but this fails if pthread.h
diff --git a/contrib/ntp/sntp/libopts/Makefile.am b/contrib/ntp/sntp/libopts/Makefile.am
index 7490a75e6ca5..72e9dc44760e 100644
--- a/contrib/ntp/sntp/libopts/Makefile.am
+++ b/contrib/ntp/sntp/libopts/Makefile.am
@@ -6,7 +6,6 @@ else
 noinst_LTLIBRARIES      = libopts.la
 endif
 libopts_la_SOURCES      = libopts.c
-libopts_la_CPPFLAGS     = -I$(srcdir)
 libopts_la_LDFLAGS      = -version-info  42:1:17
 
 EXTRA_DIST		=
@@ -14,8 +13,7 @@ BUILT_SOURCES		=
 MOSTLYCLEANFILES	=
 
 AM_CFLAGS	= $(NTP_HARD_CFLAGS) $(CC_NOFORMAT)
-AM_CPPFLAGS	= $(NTP_HARD_CPPFLAGS)
-AM_LDFLAGS	= $(NTP_HARD_LDFLAGS)
+AM_CPPFLAGS	= $(NTP_HARD_CPPFLAGS) -I$(top_srcdir)/../include
 
 libopts.c:		$(BUILT_SOURCES)
 	@: do-nothing rule to avoid default SCCS get
diff --git a/contrib/ntp/sntp/m4/ntp_compiler.m4 b/contrib/ntp/sntp/m4/ntp_compiler.m4
index ddce106fe522..7a00e64c8439 100644
--- a/contrib/ntp/sntp/m4/ntp_compiler.m4
+++ b/contrib/ntp/sntp/m4/ntp_compiler.m4
@@ -1,17 +1,10 @@
 dnl ######################################################################
 dnl Common m4sh code for compiler stuff
 AC_DEFUN([NTP_COMPILER], [
+AC_REQUIRE([AC_PROG_CC_STDC])
 
 AC_USE_SYSTEM_EXTENSIONS
 
-# Ralf Wildenhues: With per-target flags we need CC_C_O
-# AM_PROG_CC_C_O supersets AC_PROG_CC_C_O
-AM_PROG_CC_C_O
-AC_PROG_GCC_TRADITIONAL
-AC_REQUIRE([AC_PROG_CC_STDC])
-dnl AC_REQUIRE([AC_PROG_CC_C89])
-dnl AC_REQUIRE([AC_PROG_CC_C99])
-
 CC_NOFORMAT=
 CFLAGS_NTP=
 CPPFLAGS_NTP=
@@ -104,13 +97,15 @@ case "$GCC" in
 	]
     )
     #
+    # $ntp_cv_gcc_Winit_self is tested later to add the 
+    # flag to CFLAGS_NTP.
+    #
     # libopts specifically builds a string with embedded NULs.
     # This causes a bunch of distracting warnings due to -Wformat.
-    # Let's see if we can figure out how to disable these.
     #
-    CFLAGS="$SAVED_CFLAGS -Wno-format"
+    CFLAGS="$SAVED_CFLAGS -Wno-format -Wno-format-security"
     AC_CACHE_CHECK(
-	[if $CC can handle -Wno-format], 
+	[if $CC can handle -Wno-format -Wno-format-security], 
 	[ntp_cv_gcc_Wno_format],
 	[
 	    AC_COMPILE_IFELSE(
@@ -120,35 +115,44 @@ case "$GCC" in
 	    )
 	]
     )
-
     case "$ntp_cv_gcc_Wno_format" in
+      no) ntp_cv_gcc_Wno_format_truncation=no
+	  ;;
      yes)
-	CC_NOFORMAT="$CC_NOFORMAT -Wno-format"
-	;;
-     no)
-	;;
+	CC_NOFORMAT="-Wno-format -Wno-format-security"
+	CFLAGS="$SAVED_CFLAGS -Wformat -Wno-format-truncation -Werror"
+	AC_CACHE_CHECK(
+		[if $CC can handle -Wformat -Wno-format-truncation], 
+		[ntp_cv_gcc_Wno_format_truncation], 
+		[AC_COMPILE_IFELSE(
+		    [AC_LANG_PROGRAM([[]], [[]])],
+		    [ntp_cv_gcc_Wno_format_truncation=yes],
+		    [ntp_cv_gcc_Wno_format_truncation=no]
+		)	]
+	)
+	#
+	# $ntp_cv_gcc_Wno_format_truncation is tested later to add the 
+	# flag to CFLAGS.
+	#
     esac
 
     CFLAGS="$SAVED_CFLAGS"
     AS_UNSET([SAVED_CFLAGS])
-    #
-    # $ntp_cv_gcc_Winit_self is tested later to add the 
-    # flag to CFLAGS_NTP.
-    #
+
     AC_CACHE_CHECK(
 	[if linker supports omitting unused code and data],
 	[ntp_cv_gc_sections_runs],
 	[
-	    dnl  NetBSD will link but likely not run with --gc-sections
-	    dnl  http://bugs.ntp.org/1844
-	    dnl  http://gnats.netbsd.org/40401
-	    dnl  --gc-sections causes attempt to load as linux elf, with
-	    dnl  wrong syscalls in place.  Test a little gauntlet of
-	    dnl  simple stdio read code checking for errors, expecting
-	    dnl  enough syscall differences that the NetBSD code will
-	    dnl  fail even with Linux emulation working as designed.
-	    dnl  A shorter test could be refined by someone with access
-	    dnl  to a NetBSD host with Linux emulation working.
+	    #  NetBSD will link but likely not run with --gc-sections
+	    #  http://bugs.ntp.org/1844
+	    #  http://gnats.netbsd.org/40401
+	    #  --gc-sections causes attempt to load as linux elf, with
+	    #  wrong syscalls in place.  Test a little gauntlet of
+	    #  simple stdio read code checking for errors, expecting
+	    #  enough syscall differences that the NetBSD code will
+	    #  fail even with Linux emulation working as designed.
+	    #  A shorter test could be refined by someone with access
+	    #  to a NetBSD host with Linux emulation working.
 	    origCFLAGS="$CFLAGS"
 	    CFLAGS="$CFLAGS -Wl,--gc-sections"
 	    AC_LINK_IFELSE(
@@ -223,6 +227,10 @@ case "$GCC" in
      yes)
 	CFLAGS_NTP="$CFLAGS_NTP -Wstrict-overflow"
     esac
+    case "$ntp_cv_gcc_Wno_format_truncation" in
+     yes)
+	CFLAGS_NTP="$CFLAGS_NTP -Wno-format-truncation"
+    esac
     # -W[no-]strict-prototypes might be added by NTP_OPENSSL
 esac
 
diff --git a/contrib/ntp/sntp/m4/ntp_crypto_rand.m4 b/contrib/ntp/sntp/m4/ntp_crypto_rand.m4
index 9d554226f44c..391f1cbd5992 100644
--- a/contrib/ntp/sntp/m4/ntp_crypto_rand.m4
+++ b/contrib/ntp/sntp/m4/ntp_crypto_rand.m4
@@ -25,15 +25,15 @@ dnl if that's not specified:
 dnl - Look for RAND_poll and RAND_bytes
 dnl - if they exist, define USE_OPENSSL_CRYPTO_RAND
 
-AC_MSG_CHECKING([if we want to use OpenSSL's crypto random (if available)])
+AC_MSG_CHECKING([if we want to use SSL library's secure random numbers])
 AC_ARG_ENABLE(
     [openssl-random],
     [AS_HELP_STRING(
     	[--enable-openssl-random],
-	[Use OpenSSL's crypto random number functions, if available (default is yes)]
+	[+ Use SSL lib's secure random numbers]
     )],
-    [ntp_use_openssl_random=$enableval],
-    [ntp_use_openssl_random=yes]
+    [ntp_use_openssl_random=$enableval ; ntp_ssl_random_mandatory=$enableval],
+    [ntp_use_openssl_random=yes ; ntp_ssl_random_mandatory=no]
 )
 AC_MSG_RESULT([$ntp_use_openssl_random])
 
@@ -45,10 +45,33 @@ AC_CHECK_FUNCS([RAND_bytes RAND_poll])
 LIBS="$NTPO_SAVED_LIBS"
 case "$ntp_openssl$ntp_use_openssl_random$ac_cv_func_RAND_bytes$ac_cv_func_RAND_poll" in
  yesyesyesyes)
-     AC_DEFINE([USE_OPENSSL_CRYPTO_RAND], [1], [Use OpenSSL's crypto random functions])
-     ;;
- *) ntp_use_openssl_random=no ;;
+    AC_MSG_NOTICE([Using SSL library's secure random number generator])
+    AC_DEFINE([USE_OPENSSL_CRYPTO_RAND], [1], [Use OpenSSL's crypto random functions])
+    ;;
+ *)
+    ntp_use_openssl_random=no
+    AC_MSG_NOTICE([SSL library's secure random number generator unavailable.])
+    case "$ntp_ssl_random_mandatory" in
+     yes)
+	AC_MSG_ERROR(
+[No suitable SSL library was found and
+--enable-openssl-random was given..  Remove --enable-openssl-random
+if you wish to build without a cryptographically secure random number
+generator.
+
+WARNING: Use of ntp-keygen without a secure RNG may generate
+-------  keys that are predictable.]
+	)
+	;;
+     *)
+	AC_MSG_WARN(
+[WARNING: Use of ntp-keygen without a secure RNG may generate
+-------  keys that are predictable.]
+	)
+    esac
 esac
 
+AS_UNSET([ntp_ssl_random_mandatory])
+
 ]) dnl NTP_CRYPTO_RAND
 
diff --git a/contrib/ntp/sntp/m4/ntp_facilitynames.m4 b/contrib/ntp/sntp/m4/ntp_facilitynames.m4
index f58f8943890d..5b79fafe363e 100644
--- a/contrib/ntp/sntp/m4/ntp_facilitynames.m4
+++ b/contrib/ntp/sntp/m4/ntp_facilitynames.m4
@@ -1,24 +1,31 @@
 dnl ######################################################################
 dnl Check syslog.h for 'facilitynames' table
 AC_DEFUN([NTP_FACILITYNAMES], [
-AC_CACHE_CHECK([for facilitynames in syslog.h],ac_cv_HAVE_SYSLOG_FACILITYNAMES,[
-AC_TRY_COMPILE([
-#define SYSLOG_NAMES
-#include <stdlib.h>
-#include <syslog.h>
-],
-[ void *fnames; fnames = facilitynames; ],
-ac_cv_HAVE_SYSLOG_FACILITYNAMES=yes,ac_cv_HAVE_SYSLOG_FACILITYNAMES=no,ac_cv_HAVE_SYSLOG_FACILITYNAMES=cross)])
+
+AC_CACHE_CHECK(
+    [for facilitynames in syslog.h],
+    [ac_cv_HAVE_SYSLOG_FACILITYNAMES],
+    [AC_COMPILE_IFELSE(
+	[AC_LANG_PROGRAM(
+	    [[
+		#define SYSLOG_NAMES
+		#include <stdlib.h>
+		#include <syslog.h>
+	    ]],
+	    [[
+		void *fnames = facilitynames;
+	    ]]
+	)]
+	[ac_cv_HAVE_SYSLOG_FACILITYNAMES=yes],
+	[ac_cv_HAVE_SYSLOG_FACILITYNAMES=no]
+    )]
+)
 case "$ac_cv_HAVE_SYSLOG_FACILITYNAMES" in
  yes)
-    AC_DEFINE(HAVE_SYSLOG_FACILITYNAMES,1,[ ])
+    AC_DEFINE([HAVE_SYSLOG_FACILITYNAMES], [1], [syslog.h provides facilitynames])
     ;;
  no)
     AC_MSG_WARN([No facilitynames in <syslog.h>])
-    ;;
- cross)
-    AC_MSG_WARN([facilitynames in <syslog.h> - cross-compiling])
-    ;;
 esac
 ])
 dnl ======================================================================
diff --git a/contrib/ntp/sntp/m4/ntp_libevent.m4 b/contrib/ntp/sntp/m4/ntp_libevent.m4
index 14b614b465a3..451eac58fb06 100644
--- a/contrib/ntp/sntp/m4/ntp_libevent.m4
+++ b/contrib/ntp/sntp/m4/ntp_libevent.m4
@@ -74,7 +74,6 @@ case "$ntp_use_local_libevent" in
  *) # If we have (a good enough) pkg-config, see if it can find libevent
     case "$PKG_CONFIG" in
      /*)
-	AC_MSG_CHECKING([if libevent $ntp_libevent_min_version or later is installed])
 	if $PKG_CONFIG --atleast-version=$ntp_libevent_min_version libevent
 	then
 	    ntp_use_local_libevent=no
@@ -83,6 +82,7 @@ case "$ntp_use_local_libevent" in
 	     *.*) ;;
 	     *) ntp_libevent_version='(unknown)' ;;
 	    esac
+	    AC_MSG_CHECKING([if libevent $ntp_libevent_min_version or later is installed])
 	    AC_MSG_RESULT([yes, version $ntp_libevent_version])
 	    CFLAGS_LIBEVENT=`$PKG_CONFIG --cflags libevent_pthreads`
 	    CPPFLAGS_LIBEVENT=`$PKG_CONFIG --cflags-only-I libevent`
@@ -116,6 +116,7 @@ case "$ntp_use_local_libevent" in
 	    # HMS: do we only need to do this if LIBISC_PTHREADS_NOTHREADS
 	    # is "pthreads"?
 	    CFLAGS_LIBEVENT=`$PKG_CONFIG --cflags libevent_pthreads`
+	    AC_MSG_CHECKING([if libevent $ntp_libevent_min_version or later is installed])
 	    AC_MSG_RESULT([no])
 	fi
 	;;
@@ -181,14 +182,15 @@ case "$ntp_use_local_libevent" in
     dnl User-supplied contradictory choices should prevail thanks to
     dnl "last wins".
     ac_configure_args=" --disable-openssl${ac_configure_args}"
+    ac_configure_args=" --disable-samples${ac_configure_args}"
     ac_configure_args=" --disable-shared${ac_configure_args}"
     ac_configure_args=" --disable-libevent-regress${ac_configure_args}"
     ac_configure_args=" --disable-libevent-install${ac_configure_args}"
     ac_configure_args=" --enable-silent-rules${ac_configure_args}"
     ac_configure_args=" --enable-function-sections${ac_configure_args}"
-    ac_configure_args=" LEP_CFLAGS='${NTP_HARD_CFLAGS}'${ac_configure_args}"
-    ac_configure_args=" LEP_CPPFLAGS='${NTP_HARD_CPPFLAGS}'${ac_configure_args}"
-    ac_configure_args=" LEP_LDFLAGS='${NTP_HARD_LDFLAGS}'${ac_configure_args}"
+    ac_configure_args=" LIBEVENT_CFLAGS='${NTP_HARD_CFLAGS}'${ac_configure_args}"
+    ac_configure_args=" LIBEVENT_CPPFLAGS='${NTP_HARD_CPPFLAGS}'${ac_configure_args}"
+    ac_configure_args=" LIBEVENT_LDFLAGS='${NTP_HARD_LDFLAGS}'${ac_configure_args}"
     AC_CONFIG_SUBDIRS([libevent])
     ;;
  *)
diff --git a/contrib/ntp/sntp/m4/ntp_libntp.m4 b/contrib/ntp/sntp/m4/ntp_libntp.m4
index 21d0cff82c07..e0cc2169aa59 100644
--- a/contrib/ntp/sntp/m4/ntp_libntp.m4
+++ b/contrib/ntp/sntp/m4/ntp_libntp.m4
@@ -8,12 +8,13 @@ dnl subpackage while retaining access to such test results.
 dnl
 AC_DEFUN([NTP_LIBNTP], [
 
+AC_REQUIRE([AC_PROG_SED])
 AC_REQUIRE([NTP_CROSSCOMPILE])
 
 # HMS: Save $LIBS and empty it.
 # any LIBS we add here should go in to LDADD_LIBNTP
 AC_SUBST([LDADD_LIBNTP])
-__LIBS=$LIBS
+SAVED_LIBS=$LIBS
 LIBS=
 
 dnl The contents of NTP_PROG_CC used to be here...
@@ -267,7 +268,7 @@ case "$ac_cv_c_inline" in
     AC_SUBST([HAVE_INLINE])
 esac
 
-AC_HEADER_TIME
+
 AC_CHECK_SIZEOF([time_t])
 AC_C_CHAR_UNSIGNED		dnl CROSS_COMPILE?
 AC_CHECK_SIZEOF([signed char])
@@ -490,7 +491,10 @@ AC_DEFUN([NTP_BEFORE_HW_FUNC_VSNPRINTF], [
     AC_BEFORE([$0], [HW_FUNC_SNPRINTF])dnl
     AC_ARG_ENABLE(
 	[c99-snprintf],
-	[AS_HELP_STRING([--enable-c99-snprintf], [s force replacement])],
+	[AS_HELP_STRING(
+	    [--enable-c99-snprintf],
+	    [s use replacement printf family]
+	)],
 	[force_c99_snprintf=$enableval],
 	[force_c99_snprintf=no]
 	)
@@ -501,15 +505,8 @@ AC_DEFUN([NTP_BEFORE_HW_FUNC_VSNPRINTF], [
     esac
     AH_VERBATIM(
 	[snprinte],dnl	sorted in config.h just before #define snprintf
-	[
-	    #if !defined(_KERNEL) && !defined(PARSESTREAM)
-	    /*
-	     * stdio.h must be included after _GNU_SOURCE is defined
-	     * but before #define snprintf rpl_snprintf
-	     */
-	    # include <stdio.h>	
-	    #endif
-	])
+	[#include "c99_snprintf.h"]
+    )
     AH_BOTTOM([
 	#if !defined(_KERNEL) && !defined(PARSESTREAM)
 	# if defined(HW_WANT_RPL_VSNPRINTF)
@@ -752,62 +749,6 @@ typedef unsigned int	uintptr_t;
 #define HAVE_UINTPTR_T	1
 #endif])
 
-case "$ac_cv_type_int32::$ac_cv_header_resolv_h" in
- no::yes)
-    AC_CACHE_CHECK(
-	[for int32 with DNS headers included],
-	[ntp_cv_type_int32_with_dns],
-	[AC_COMPILE_IFELSE(
-	    [AC_LANG_PROGRAM(
-		[[
-		    #ifdef HAVE_ARPA_NAMESER_H
-		    # include <arpa/nameser.h>
-		    #endif
-		    #include <resolv.h>
-		]],
-		[[
-		    size_t cb = sizeof(int32);
-		]]
-	    )],
-	    [ntp_cv_type_int32_with_dns=yes],
-	    [ntp_cv_type_int32_with_dns=no]
-	)]
-    )
-    case "$ntp_cv_type_int32_with_dns" in
-     yes)
-	AC_DEFINE([HAVE_INT32_ONLY_WITH_DNS], [1],
-	    [int32 type in DNS headers, not others.])
-    esac
-esac
-
-case "$ac_cv_type_u_int32::$ac_cv_header_resolv_h" in
- no::yes)
-    AC_CACHE_CHECK(
-	[for u_int32 with DNS headers included],
-	[ntp_cv_type_u_int32_with_dns],
-	[AC_COMPILE_IFELSE(
-	    [AC_LANG_PROGRAM(
-		[[
-		    #ifdef HAVE_ARPA_NAMESER_H
-		    # include <arpa/nameser.h>
-		    #endif
-		    #include <resolv.h>
-		]],
-		[[
-		    size_t cb = sizeof(u_int32);
-		]]
-	    )],
-	    [ntp_cv_type_u_int32_with_dns=yes],
-	    [ntp_cv_type_u_int32_with_dns=no]
-	)]
-    )
-    case "$ntp_cv_type_u_int32_with_dns" in
-     yes)
-	AC_DEFINE([HAVE_U_INT32_ONLY_WITH_DNS], [1],
-	    [u_int32 type in DNS headers, not others.])
-    esac
-esac
-
 AC_CHECK_HEADERS(
     [sys/timepps.h],
     [],
@@ -1176,11 +1117,19 @@ case "$ntp_warning" in
     ;;
 esac
 
+dnl Do not ensure libntp.a is up to date when building client directories
+dnl if --disable-dependency-tracking is used to save build time for one-off
+dnl build from tarball.  It's only useful when modifying libntp source code
+dnl and rebuilding in a client subdir rather than the whole package.
+AM_CONDITIONAL([LIBNTP_SUBMAKES], [test x"$enable_dependency_tracking" = x"yes"])
+
+NTP_OPENSSL
+NTP_CRYPTO_RAND
 
 dnl add to LDADD_LIBNTP set by ntp_compiler.m4
 LDADD_LIBNTP="$LDADD_LIBNTP $LIBS"
-LIBS=$__LIBS
-AS_UNSET([__LIBS])
+LIBS=$SAVED_LIBS
+AS_UNSET([SAVED_LIBS])
 
 ])dnl
 dnl ======================================================================
